SystemOrganization addCategory: #ConfigurationOfRealInterval!

Object subclass: #ConfigurationOfRealInterval
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfRealInterval'!

!ConfigurationOfRealInterval commentStamp: 'WernerKassens 3/18/2016 11:41' prior: 0!
do 'ConfigurationOfRealInterval  load.' or 'ConfigurationOfRealInterval  loadDevelopment .'

 if you do this this, there will first be made a test whether RealInterval is probably compatible with your image, and if it is not, nothing is loaded. you can then run TestOldMethods (see comment there), load 'core' and adjust the methods accordingly.!

!ConfigurationOfRealInterval class methodsFor: 'development support' stamp: 'WernerKassens 1/30/2016 15:02'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfRealInterval class methodsFor: 'private' stamp: 'WernerKassens 1/30/2016 15:02'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfRealInterval class methodsFor: 'private' stamp: 'WernerKassens 1/30/2016 15:02'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfRealInterval class methodsFor: 'private' stamp: 'WernerKassens 1/30/2016 15:02'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfRealInterval class methodsFor: 'metacello tool support' stamp: 'WernerKassens 1/30/2016 15:02'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfRealInterval class methodsFor: 'loading' stamp: 'WernerKassens 1/30/2016 15:02'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfRealInterval class methodsFor: 'loading' stamp: 'WernerKassens 1/30/2016 15:02'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfRealInterval class methodsFor: 'loading' stamp: 'WernerKassens 1/30/2016 15:02'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfRealInterval class methodsFor: 'accessing' stamp: 'WernerKassens 1/30/2016 15:02'!
project

	^self new project! !

!ConfigurationOfRealInterval class methodsFor: 'development support' stamp: 'WernerKassens 1/30/2016 15:02'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfRealInterval methodsFor: 'baselines' stamp: 'WernerKassens 3/19/2016 18:05'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec description: 'initial version'.
		spec author: 'WernerKassens'.
		spec timestamp: '2016-01-30T15:13:14.484483+01:00'.
		spec repository: 'http://smalltalkhub.com/mc/SergeStinckwich/SciSmalltalk/main/'.

		spec project: 'SMark'	with: [ 
		  spec className: #ConfigurationOfSMark;
					versionString: '1.0.1';
					repository: 'http://smalltalkhub.com/mc/StefanMarr/SMark/main' ].
		spec project: 'Roassal2' with: [  
		  spec className: 'ConfigurationOfRoassal2';
               versionString: #stable;
               repository: 'http://www.smalltalkhub.com/mc/ObjectProfile/Roassal2/main'].
		spec project: 'SciST' with: [  
		  spec className: 'ConfigurationOfSciSmalltalk';
               versionString: #stable;
               repository: 'http://smalltalkhub.com/mc/SergeStinckwich/SciSmalltalk/main/';
					loads: #('Math-DHB-Numerical' 'Math-DHB-wk' 'Math-Number-Extensions')].

		spec package: 'Math-Tests-RealInterval-Compatibility'.
		spec package:'Math-RealIntervalCompatibility'.
		spec package: 'Math-Benchmarks-RealInterval'
			with: [spec requires: #('Math-RealInterval' 'Math-Tests-RealInterval' 'SMark' 'Math-RealIntervalCompatibility')].
		spec package: 'Math-RealInterval'with: [spec requires: #('Roassal2' 'SciST')].
		spec package: 'Math-Tests-RealInterval' with: [spec requires: #('Math-RealInterval' 'SciST' 'Roassal2')].

		spec group: 'test' with: #('Math-Tests-RealInterval-Compatibility' 'Math-Tests-RealInterval' 'Math-Benchmarks-RealInterval').
		spec group: 'core' with: #('Math-RealInterval' 'Math-RealIntervalCompatibility').
		spec group: 'default' with: #('Math-Tests-RealInterval-Compatibility').
		spec for: #'RILoadable' do:[ spec group: 'default' with: #('core' 'test')]].
	! !

!ConfigurationOfRealInterval methodsFor: 'accessing' stamp: 'WernerKassens 3/19/2016 18:08'!
customProjectAttributes
|a|
a:=OrderedCollection new.
a add:((SystemVersion current major < 5 or:[Smalltalk vm isSpur not])
	ifTrue: [#isNoSpur] ifFalse: [#isSpur]).
[Gofer new 
	directory:'http://smalltalkhub.com/mc/SergeStinckwich/SciSmalltalk/main/';
	package:'Math-Tests-RealInterval-Compatibility';
	load]on: Error do:[:e|(Smalltalk hasClassNamed: 'TestOldMethods')
		ifFalse:[self warning:'RealInterval will not be loaded because TestOldMethods was not found'. ^a] ].
TestOldMethods isProblematic 
	ifFalse: [a add:#RILoadable] 
	ifTrue:[self warning:'RealInterval will not be loaded because of incompatibilities'].
^a! !

!ConfigurationOfRealInterval methodsFor: 'symbolic versions' stamp: 'WernerKassens 2/7/2016 10:18'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.1'.
! !

!ConfigurationOfRealInterval methodsFor: 'accessing' stamp: 'WernerKassens 1/30/2016 15:02'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfRealInterval methodsFor: 'symbolic versions' stamp: 'WernerKassens 3/18/2016 11:32'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.2'.
! !

!ConfigurationOfRealInterval methodsFor: 'versions' stamp: 'WernerKassens 2/7/2016 17:42'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline' )>
	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'initial version'.
		spec author: 'WernerKassens'.
		spec timestamp: '2/6/2016 13:46'.
		spec package: 'Math-Benchmarks-RealInterval'
				with:'Math-Benchmarks-RealInterval-WernerKassens.1'.
		spec package: 'Math-Tests-RealInterval' with:'Math-Tests-RealInterval-WernerKassens.16'.
		spec package: 'Math-RealInterval'with:'Math-RealInterval-WernerKassens.104'.
		spec for: #isNoSpur do: [		
			spec package: 'Math-RealIntervalCompatibility' 				with:'Math-RealIntervalCompatibility-WernerKassens.1'].
		spec for: #isSpur do: [
			spec package:'Math-RealIntervalCompatibility' with: 				'Math-RealIntervalCompatibility-WernerKassens.2']]! !

!ConfigurationOfRealInterval methodsFor: 'versions' stamp: 'WernerKassens 3/19/2016 18:10'!
version11: spec
	<version: '1.1' imports: #('1.0-baseline' )>
	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: 'exclusively for development. loads the latest versions of packages apart from Math-RealIntervalCompatibility which needs to stay fixed. essentially works like the usual baseline load (most packages are intentionally not specified, which makes it work like a baseline)'.
		spec author: 'WernerKassens'.
		spec timestamp: '2/7/2016 13:46'.
		spec project: 'SciST' with: [spec versionString: #'development'].
		spec for: #isNoSpur do: [		
			spec package: 'Math-RealIntervalCompatibility' 					with:'Math-RealIntervalCompatibility-WernerKassens.3'].
		spec for: #isSpur do: [
			spec package:'Math-RealIntervalCompatibility' 
					with:'Math-RealIntervalCompatibility-WernerKassens.4']]! !

!ConfigurationOfRealInterval methodsFor: 'versions' stamp: 'WernerKassens 3/19/2016 13:26'!
version12: spec
	<version: '1.2' imports: #('1.0-baseline' )>
	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'probably ok'.
		spec author: 'WernerKassens'.
		spec timestamp: '3/18/2016 13:46'.
		spec package: 'Math-Benchmarks-RealInterval'
				with:'Math-Benchmarks-RealInterval-WernerKassens.2'.
		spec package: 'Math-Tests-RealInterval' with:'Math-Tests-RealInterval-WernerKassens.26'.
		spec package: 'Math-RealInterval'with:'Math-RealInterval-WernerKassens.124'.
		spec for: #isNoSpur do: [		
			spec package: 'Math-RealIntervalCompatibility' 				with:'Math-RealIntervalCompatibility-WernerKassens.3'].
		spec for: #isSpur do: [
			spec package:'Math-RealIntervalCompatibility' with: 				'Math-RealIntervalCompatibility-WernerKassens.4']]! !

!ConfigurationOfRealInterval methodsFor: 'private' stamp: 'WernerKassens 2/18/2016 16:49'!
warning:aString
GrowlMorph 
			openWithLabel: 'Warning' 
			contents: aString
			color: Color orange darker! !
